/* THIS FILE IS AUTOGENERATED FROM CameraUtil.webidl BY Codegen.py - DO NOT EDIT */

#ifndef mozilla_dom_CameraUtilBinding_h
#define mozilla_dom_CameraUtilBinding_h

#include "CameraManagerBinding.h"
#include "DOMCameraControl.h"
#include "js/RootingAPI.h"
#include "jspubtd.h"
#include "mozilla/ErrorResult.h"
#include "mozilla/dom/BindingDeclarations.h"
#include "mozilla/dom/Nullable.h"

namespace mozilla {

class nsDOMCameraControl;

namespace dom {

struct CameraConfiguration;
struct CameraGetPromiseDataAtoms;
struct NativePropertyHooks;
class ProtoAndIfaceCache;

} // namespace dom

} // namespace mozilla

namespace mozilla {
namespace dom {

struct CameraGetPromiseData : public DictionaryBase
{
  RefPtr<mozilla::nsDOMCameraControl> mCamera;
  CameraConfiguration mConfiguration;

  CameraGetPromiseData();

  explicit inline CameraGetPromiseData(const FastDictionaryInitializer& )
    : mConfiguration(FastDictionaryInitializer())
  {
    // Do nothing here; this is used by our "Fast" subclass
  }

  explicit inline CameraGetPromiseData(const CameraGetPromiseData& aOther)
    : mConfiguration(FastDictionaryInitializer())
  {
    *this = aOther;
  }

  bool
  Init(JSContext* cx, JS::Handle<JS::Value> val, const char* sourceDescription = "Value", bool passedToJSImpl = false);

  bool
  Init(const nsAString& aJSON);

  bool
  ToObjectInternal(JSContext* cx, JS::MutableHandle<JS::Value> rval) const;

  bool
  ToJSON(nsAString& aJSON) const;

  void
  TraceDictionary(JSTracer* trc);

  void
  operator=(const CameraGetPromiseData& aOther);

private:
  static bool
  InitIds(JSContext* cx, CameraGetPromiseDataAtoms* atomsCache);
};

namespace binding_detail {
struct FastCameraGetPromiseData : public CameraGetPromiseData
{
  inline FastCameraGetPromiseData()
    : CameraGetPromiseData(FastDictionaryInitializer())
  {
    // Doesn't matter what int we pass to the parent constructor
  }
};
} // namespace binding_detail


} // namespace dom
} // namespace mozilla

#endif // mozilla_dom_CameraUtilBinding_h
